#encoding: UTF-8
require "netpay_ecommerce_ruby/version"
require "netpay_ecommerce_ruby/ecommerce_service"
require "netpay_ecommerce_ruby/netpay_config"

module NetpayEcommerce
  class Error < StandardError; end
  def self.send options
      # Send request to netpay ecommerce. 
      #
      # Example:
      #   >> NetpayEcommerce.send({ service: "login", body: body})
      #   => "200"
      #
      # Arguments availables in the option:
      #   service: (String)
      #   body: (Object or Json)
      #   prd_mode: (Boolean, default is false)
      #   token: (String)
      #   transport: define the format of body, default is a ruby hash(Json)

    EcommerceService::Request.new(options).send
  end
end