#encoding: UTF-8
require 'net/http'
require "uri"
require "json"
require "netpay_ecommerce_ruby/helpers/helper_config"
require "netpay_ecommerce_ruby/helpers/helper_service"

module EcommerceService
  class Request
    def initialize options = {}
      @service = options.fetch(:service, 'NONE').upcase
      @body    = options.fetch(:body, nil)
      prd_mode = options.fetch(:prd_mode, false)
      if prd_mode
        @host = NetpayConfig::HOST_PRD
      else
        @host = NetpayConfig::HOST_CERT
      end
      @token     = options.fetch(:token, false)
      @transport = options.fetch(:transport_method, nil)
    end

    def send
      response_service, is_valid = HelperConfig::Config.endpointAction @service
      if is_valid
        instance_service = HelperService::Service.new(
                            {
                              service_name: response_service[:service_name],
                              method: response_service[:method], 
                              security_token: response_service[:security_token],
                              host: @host,
                              body: @body,
                              token: @token,
                              transport_method: @transport 
                            }
                          )
        response_service = instance_service.send_request
      end
      self.format_response(response_service, is_valid)
    end

    def format_response response, valid
      if valid
        response
      else
        [response, false]
      end
    end

  end
end